<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
<topic id="integrate-google-search-whresponsive">
  <title>How to Integrate Google Search in WebHelp Responsive Output</title>
  <titlealts product="webhelp-responsive">
    <navtitle>How to Integrate Google Search</navtitle>
  </titlealts>
  <prolog>
    <metadata>
      <keywords>
        <indexterm product="author developer editor authorEclipse developerEclipse editorEclipse"
          >WebHelp Responsive<indexterm>Google Search</indexterm></indexterm>
        <indexterm product="webhelp-responsive ope">Google Search</indexterm>
      </keywords>
    </metadata>
  </prolog>
  <body>
    <p id="p_el4_cgk_54b">It is possible to integrate the <term>Google Search Engine</term> into your <b>WebHelp
        Responsive</b> output and you can specify where you want the results to appear in your
      WebHelp page.</p>
    <section id="using_a_script_outside_of_oxygen_xml_editorauthor">
      <title>Using a Publishing Template</title>
      <p id="p_fl4_cgk_54b">To integrate the <term>Google Search Engine</term> into your WebHelp Responsive output
        using an <xref keyref="wh-publishing-template"><term>Oxygen Publishing
          Template</term></xref>, follow this procedure:<ol id="ol_gl4_cgk_54b">
          <li id="li_hl4_cgk_54b">Go to the <xref href="https://cse.google.com/cse/" format="html" scope="external"
              >Google Custom Search Engine page</xref> using your Google account.</li>
          <li id="li_il4_cgk_54b">Select the <uicontrol>Create a custom search engine</uicontrol> button.</li>
          <li id="li_jl4_cgk_54b">Follow the on-screen instructions to create a search engine component for your
              site.<note type="important" id="note_kl4_cgk_54b">For the <uicontrol>Layout</uicontrol>, you must select
                <uicontrol>Results only</uicontrol> for the <term>Google Search Engine</term> to
              work with <b>Oxygen XML WebHelp Responsive</b>.</note></li>
          <li id="li_ll4_cgk_54b">At the end of this process you should obtain a code snippet that looks like
            this:<codeblock  id="codeblock_ml4_cgk_54b">&lt;script>   
 (function()  {     
  var cx =
    '000888210889775888983:8mn4x_mf-yg';     
  var gcse = document.createElement('script'); 
  gcse.type = 'text/javascript'; 
  gcse.async = true;     
  gcse.src = (document.location.protocol == 'https:' ?
    'https:' : 'http:') +         '//www.google.com/cse/cse.js?cx=' + cx;     
  var s = document.getElementsByTagName('script')[0]; 
  s.parentNode.insertBefore(gcse, s);   
 }
 )(); 
&lt;/script></codeblock></li>
          <li id="li_nl4_cgk_54b">Save the script into a well-formed HTML file called
              <filepath>googlecse.html</filepath>.</li>
          <li id="li_ol4_cgk_54b">Open the <xref href="whr_publishing_template_contents.dita#template_descritpor_file"
              >template descriptor file</xref> associated with your publishing template and add the
              <codeph>webhelp.google.search.script</codeph> parameter in the <term>parameters</term>
            section with its value set to reference the <filepath>googlecse.html</filepath> file
            that you created
            earlier.<codeblock  id="codeblock_pl4_cgk_54b">&lt;publishing-template>
  ...
  &lt;webhelp>
     ...                
     &lt;parameters>
         &lt;parameter 
             name="webhelp.google.search.script" 
             value="resources/googlecse.html"
             type="filePath"/>
     &lt;/parameters>
  &lt;/webhelp></codeblock></li>
          <li id="li_ql4_cgk_54b">You can also use the <codeph>webhelp.google.search.results</codeph> parameter to
            choose where to display the search results.<ol id="ol_rl4_cgk_54b">
              <li id="li_sl4_cgk_54b">Create an HTML file with the following content: <codeph>&lt;div
                  class="gcse-searchresults-only" data-autoSearchOnLoad="true"
                  data-queryParameterName="searchQuery">&lt;/div></codeph> (you must use the <xref
                  href="https://developers.google.com/custom-search/docs/element#html5"
                  format="html" scope="external">HTML5 version for the GCSE</xref>). For more
                information about other supported attributes, see <xref
                  href="https://developers.google.com/custom-search/docs/element#supported_attributes"
                  format="html" scope="external">Google Custom Search: Supported
                Attributes</xref>.</li>
              <li id="li_tl4_cgk_54b">Set the value of the <codeph>webhelp.google.search.results</codeph> parameter to
                the file path of the file you just created. If this parameter is not specified, the
                following code is used: <codeph>&lt;div class="gcse-searchresults-only"
                  data-autoSearchOnLoad="true"
                  data-queryParameterName="searchQuery">&lt;/div></codeph>.</li>
            </ol></li>
          <li id="li_ul4_cgk_54b">Open the <term>DITA Map WebHelp Responsive</term> transformation scenario.</li>
          <li id="li_vl4_cgk_54b">Click the <uicontrol>Choose Custom Publishing Template</uicontrol> link and select
            your template.</li>
          <li id="li_wl4_cgk_54b">Click <uicontrol>OK</uicontrol> to save the changes to the transformation
            scenario.</li>
          <li id="li_xl4_cgk_54b">Run the transformation scenario.</li>
        </ol></p>
    </section>
    <section id="using_oxygen_xml_editorauthor">
      <title>Using a Transformation Scenario in Oxygen XML Editor/Author</title>
      <p id="p_yl4_cgk_54b">To integrate the <term>Google Search Engine</term> into your WebHelp Responsive output
        using a transformation scenario from within <b>Oxygen XML Editor/Author</b>, follow this procedure:<ol id="ol_zl4_cgk_54b">
          <li id="li_am4_cgk_54b">Go to the <xref href="https://cse.google.com/cse/" format="html" scope="external"
              >Google Custom Search Engine page</xref> using your Google account.</li>
          <li id="li_bm4_cgk_54b">Select the <uicontrol>Create a custom search engine</uicontrol> button.</li>
          <li id="li_cm4_cgk_54b">Follow the on-screen instructions to create a search engine for your site.<note
              type="important" id="note_dm4_cgk_54b">For the <uicontrol>Layout</uicontrol>, you must select
                <uicontrol>Results only</uicontrol> for the <term>Google Search Engine</term> to
              work with <b>Oxygen XML WebHelp Responsive</b>.</note></li>
          <li id="li_em4_cgk_54b">At the end of this process you should obtain a code snippet that looks like
            this:<codeblock  id="codeblock_fm4_cgk_54b">&lt;script>   
 (function()  {     
  var cx =
    '000888210889775888983:8mn4x_mf-yg';     
  var gcse = document.createElement('script'); 
  gcse.type = 'text/javascript'; 
  gcse.async = true;     
  gcse.src = (document.location.protocol == 'https:' ?
    'https:' : 'http:') +         '//www.google.com/cse/cse.js?cx=' + cx;     
  var s = document.getElementsByTagName('script')[0]; 
  s.parentNode.insertBefore(gcse, s);   
 }
 )(); 
&lt;/script></codeblock></li>
          <li id="li_gm4_cgk_54b">Save the script into a well-formed HTML file called
              <filepath>googlecse.html</filepath>.</li>
          <li id="li_hm4_cgk_54b">Edit the <term>DITA Map WebHelp Responsive</term> transformation scenario and choose a
              <i>template</i>.</li>
          <li id="li_im4_cgk_54b">Switch to the <uicontrol>Parameters</uicontrol> tab and edit the
              <codeph>webhelp.google.search.script</codeph> parameter to reference the
              <filepath>googlecse.html</filepath> file that you created earlier.</li>
          <li id="li_jm4_cgk_54b">You can also use the <codeph>webhelp.google.search.results</codeph> parameter to
            choose where to display the search results.<ol id="ol_km4_cgk_54b">
              <li id="li_lm4_cgk_54b">Create an HTML file with the following content: <codeph>&lt;div
                  class="gcse-searchresults-only" data-autoSearchOnLoad="true"
                  data-queryParameterName="searchQuery">&lt;/div></codeph> (you must use the <xref
                  href="https://developers.google.com/custom-search/docs/element#html5"
                  format="html" scope="external">HTML5 version for the GCSE</xref>). For more
                information about other supported attributes, see <xref
                  href="https://developers.google.com/custom-search/docs/element#supported_attributes"
                  format="html" scope="external">Google Custom Search: Supported
                Attributes</xref>.</li>
              <li id="li_mm4_cgk_54b">Set the value of the <codeph>webhelp.google.search.results</codeph> parameter to
                the file path of the file you just created. If this parameter is not specified, the
                following code is used: <codeph>&lt;div class="gcse-searchresults-only"
                  data-autoSearchOnLoad="true"
                  data-queryParameterName="searchQuery">&lt;/div></codeph>.</li>
            </ol></li>
          <li id="li_nm4_cgk_54b">Click <uicontrol>Ok</uicontrol> and run the transformation scenario.</li>
        </ol></p>
    </section>
  </body>
</topic>
